#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 White
#property indicator_style1 2
#property indicator_width1 1

double TodayOpenBuffer[];
extern int TimeZoneOfData= 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	SetIndexStyle(0,DRAW_LINE);
	SetIndexBuffer(0,TodayOpenBuffer);
	SetIndexLabel(0,"Open");
	SetIndexEmptyValue(0,0.0);
	return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int lastbar;
   int counted_bars= IndicatorCounted();
   
   if (counted_bars>0) counted_bars--;
   lastbar = Bars-counted_bars;	
   DailyOpen(0,lastbar);
   WriteComent();
   return (0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int DailyOpen(int offset, int lastbar)
{
   int shift;
   int tzdiffsec= TimeZoneOfData * 3600;
   double barsper30= 1.0*PERIOD_M30/Period();
   bool ShowDailyOpenLevel= True;
   // lastbar+= barsperday+2;  // make sure we catch the daily open		 
   lastbar= MathMin(Bars-20*barsper30-1, lastbar);

	for(shift=lastbar;shift>=offset;shift--){
	  TodayOpenBuffer[shift]= 0;
     if (ShowDailyOpenLevel){
       if(TimeDay(Time[shift]-tzdiffsec) != TimeDay(Time[shift+1]-tzdiffsec))
       {
         TodayOpenBuffer[shift]= Open[shift];         
         TodayOpenBuffer[shift+1]= 0; 
       }
       else
       {
         TodayOpenBuffer[shift]= TodayOpenBuffer[shift+1];
       }
	  }
   }
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int WriteComent()
{
   int i=0, max_yesterday, min_yesterday;
   double rez, h, l;
   int hour = iTime(NULL, 0, 0);
   int Bar_shift_hour = iBarShift(NULL, PERIOD_D1, hour);
   int Time_Day = iTime(NULL, PERIOD_D1, Bar_shift_hour) + TimeZoneOfData;
   int Time_Yesterday=Time_Day-86400; 
   if (TimeDayOfWeek(Time_Day)==0) Time_Yesterday=Time_Day-86400*2; 
   if (TimeDayOfWeek(Time_Day)==1) Time_Yesterday=Time_Day-86400*3;
   int Bar_Day=iBarShift(NULL,0,Time_Day+TimeZoneOfData);
   int Bar_Yesterday=iBarShift(NULL,0,Time_Yesterday+TimeZoneOfData);
         i=Bar_Yesterday-Bar_Day;
         max_yesterday=iHighest(NULL, 0, MODE_HIGH,i, Bar_Day+1);
         min_yesterday=iLowest (NULL, 0, MODE_LOW ,i, Bar_Day+1);
         h=High[max_yesterday];
         l=Low[min_yesterday];
         rez=(h-l)/Point;
         
    Comment (WindowExpertName(	),"\n","\n",

          "   max  min      = ",rez,"\n",
          "    = ",DoubleToStr(Open[Bar_Day],5));
          
      return(0);
}